/**
 * Created by h148225 on 12/1/2016.
 */



define(['baja!',
        'jquery',
        'Promise',
        'underscore',
        'dialogs',
        'nmodule/sbcOfflineEngineering/rc/js/util/Progress',
        'hbs!nmodule/sbcOfflineEngineering/rc/hbs/scanView',
        'lex!sbcOfflineEngineering'
    ],
    function (baja,
              $,
              Promise,
              _,
              Dialogs,
              progress,
              template,
              Lexicons) {

        'use strict';

        /**
         * Description of your widget.
         *
         * @class
         * @alias module:nmodule/sbcOfflineEngineering/rc/js/OfflineEngineeringscanView
         */
        var scanView = new function () {

            var lex = Lexicons[0];
            var $element = null;
            var selectedModules = {};
            var scanStatus = {};
            var scannedList = {datapoints:0, alarms:0, hdlogs:0};
            var sbcService = null;
            var $widgetContainer =  null;
            var isProcessCancelled = false;
            var cancelDialog = null;


            var modifyUserSelections = function(){
                var dflag = false, aflag = false, hflag = false;
                if(selectedModules.datapoints && !scannedList.datapoints){
                    selectedModules.datapoints = false;
                    dflag = true;
                }

                if(!selectedModules.datapoints){
                    dflag = true;
                }

                if(selectedModules.alarms && !scannedList.alarms){
                    selectedModules.alarms = false;
                    aflag = true;
                }

                if(!selectedModules.alarms){
                    aflag = true;
                }
                if(selectedModules.hdlogs && !scannedList.hdlogs){
                    selectedModules.hdlogs = false;
                    hflag = true;
                }
                if(!selectedModules.hdlogs){
                    hflag = true;
                }
                return (dflag && aflag && hflag);
            }

            var _startStopScanning = function (stopScan) {

                if(stopScan) {
                    if(scanStatus.datapoints) {
                        _stopScanning('datapoints');
                        scanStatus.datapoints = 0;
                    } else if(scanStatus.alarms) {
                        _stopScanning('alarms');
                        scanStatus.alarms = 0;
                    }  else if(scanStatus.hdlogs) {
                        _stopScanning('hdlogs');
                        scanStatus.hdlogs = 0;
                    }
                }
                if(!isProcessCancelled) {
                    if(scanStatus.datapoints) {
                        _startScanning('datapoints');
                    } else if(scanStatus.alarms) {
                        _startScanning('alarms');
                    }  else if(scanStatus.hdlogs) {
                        _startScanning('hdlogs');
                    } else {
                        
                        //Note: if any of the resources selected has zero scanned items, do no allow to go to next!
                        if((selectedModules.datapoints && !scannedList.datapoints) ||
                            (selectedModules.alarms && !scannedList.alarms) ||
                            (selectedModules.hdlogs && !scannedList.hdlogs)) {
                            $widgetContainer.find("#sbcOfflineEngineering-cancelBttn").prop( "disabled", true);
                            $widgetContainer.find("#sbcOfflineEngineering-backBttn").prop("disabled", false);
                            var output = modifyUserSelections();
                            var message;
                            if(output){
                                $widgetContainer.find("#sbcOfflineEngineering-nextBttn").prop("disabled", true);
                                message = lex.get("sbc.offlineEngineering.scan.noResource.msg1");
                            }else{
                                $widgetContainer.find("#sbcOfflineEngineering-nextBttn").prop("disabled", false);
                                message = lex.get("sbc.offlineEngineering.scan.noResource.msg");
                            }
                            var errorMsgDiv = $element.find("#scan-error");
                            errorMsgDiv.html(message);
                            errorMsgDiv.css('display', 'block');

                            /*Dialogs.showOk({
                                title : lex.get("sbc.offlineEngineering.dialog.error"),
                                content:lex.get("sbc.offlineEngineering.scan.noResource.msg")
                            });*/

                        } else {
                            // Scanning is complete - now enable navigation and update status
                            _updateBttnsOnComplete();
                            $element.find("#scanView  #sbcOfflineEngineering-status-message").html(lex.get("sbc.offlineEngineering.scan.complete"));
                        }
                        //irrespective of any resources scanned or not, hide the cancel dialog (if present) once scanning is done.
                        if(cancelDialog != null) {
                            cancelDialog.close();
                            cancelDialog = null;
                        }
                    }
                }

            };

            var _startScanning = function(type) {
                switch (type) {
                    case 'datapoints':
                        var datapointsContainer  = sbcService.getDataPoints();
                        progress.prototype.startDatapointsTimer();
                        sbcService.invoke({
                            slot: "scanDataPoints"
                        });
                        _updateBttnsOnScan();
                        break;
                    case 'alarms':
                        var alarmsContainer = sbcService.getAlarms();
                        progress.prototype.startAlarmsTimer();
                        sbcService.invoke({
                            slot: "scanAlarms"
                        });
                        _updateBttnsOnScan();
                        break;
                    case 'hdlogs':
                        var hdlogsContainer = sbcService.getHdLogs();
                        progress.prototype.startHDLogsTimer();
                        sbcService.invoke({
                            slot: "scanHDLogs"
                        });
                        _updateBttnsOnScan();
                        break;
                    default:
                        console.log("SBC service doesn't support scanning of " + type);
                }
            };

            var _stopScanning = function(type) {
                switch (type) {
                    case 'datapoints':
                        var datapointsContainer  = sbcService.getDataPoints();
                        scannedList.datapoints = datapointsContainer.getScannedDataPointsCount();
                        progress.prototype.stopDatapointsTimer(isProcessCancelled || sbcService.getIsScanCancelled());
                        break;
                    case 'alarms':
                        var alarmsContainer = sbcService.getAlarms();
                        scannedList.alarms = alarmsContainer.getScannedAlarmListCount();
                        progress.prototype.stopAlarmsTimer(isProcessCancelled || sbcService.getIsScanCancelled());
                        break;
                    case 'hdlogs':
                        var hdlogsContainer = sbcService.getHdLogs();
                        scannedList.hdlogs = hdlogsContainer.getScannedHDLogsCount();
                        progress.prototype.stopHDLogsTimer(isProcessCancelled || sbcService.getIsScanCancelled());
                        break;
                    default:
                        console.log("SBC service doesn't support scanning of " + type);
                }

            };

            var _updateBttnsOnScan = function() {
                $widgetContainer.find("#sbcOfflineEngineering-cancelBttn").prop( "disabled", false);
                $widgetContainer.find("#sbcOfflineEngineering-backBttn").prop("disabled", true);
                $widgetContainer.find("#sbcOfflineEngineering-nextBttn").prop("disabled", true);
            };

            var _updateBttnsOnCancel = function () {
                $widgetContainer.find("#sbcOfflineEngineering-cancelBttn").prop( "disabled", true);
                $widgetContainer.find("#sbcOfflineEngineering-backBttn").prop("disabled", false);
                $widgetContainer.find("#sbcOfflineEngineering-nextBttn").prop("disabled", false);
            };

            var _updateBttnsOnComplete = function () {
                $widgetContainer.find("#sbcOfflineEngineering-cancelBttn").prop( "disabled", true);
                $widgetContainer.find("#sbcOfflineEngineering-backBttn").prop("disabled", false);
                $widgetContainer.find("#sbcOfflineEngineering-nextBttn").prop("disabled", false);
            };

            var _attachSubscriber = function(prop, cx) {
                var service = this;
                var propName = prop.getName();
                console.log("Property name: "+prop.getName());

                if (propName === "dataPointsScanningState"){
                    if(!service.getDataPointsScanningState()){
                        //stop datapoints timer
                        _startStopScanning(true);
                    }
                } else  if (propName === "scannedDataPointsCount"){
                    //update datapoints count text
                    progress.prototype.setDatapointsCount(service.getScannedDataPointsCount());
                } else if (propName === "alarmListScanningState"){
                    if(!service.getAlarmListScanningState()){
                        //stop datapoints timerno
                        _startStopScanning(true);
                    }
                } else if (propName === "hdLogsScanningState"){
                    if(!service.getHdLogsScanningState()){
                        //stop datapoints timerno
                        _startStopScanning(true);
                    }
                } else  if (propName === "scannedAlarmListCount"){
                    //update datapoints count text
                    progress.prototype.setAlarmsCount(service.getScannedAlarmListCount());
                } else  if (propName === "scannedHDLogsCount"){
                    //update datapoints count text
                    progress.prototype.setHDLogsCount(service.getScannedHDLogsCount());
                }

            };

            var _resetData = function () {
                selectedModules = {};
                scanStatus = {};
                scannedList = {datapoints:0, alarms:0, hdlogs:0};
            };

            var _cancelScanOperation = function(sbc_service){
                $widgetContainer.find("#scanView #sbcOfflineEngineering-status-message").html(lex.get("sbc.offlineEngineering.cancel.status"));
                $widgetContainer.find("#sbcOfflineEngineering-cancelBttn").prop("disabled", true);
                _updateBttnsOnCancel();
                sbc_service.setIsScanCancelled(false); //reset the flag
                sbc_service.invoke({
                    slot: "clearScannedInfo",
                    value: 1 //Cancel scan
                });
            };

            return {

                /**
                 *
                 * @param element: dom element the view will be added to
                 * @param params: javascript object with widget parameters required to load the view within the widget
                 */

                loadView: function (element, params) {
                    _resetData();
                    $element = $(element);
                    $widgetContainer = (params.widgetContainer) ?  $(params.widgetContainer) : (element).closest(".sbcOfflineEngineering-wizard");
                    selectedModules = $.extend(true, {}, params.selectedModules);
                    scanStatus = $.extend(true, {}, params.selectedModules);

                    sbcService = params.component;
                    var subscriber = params.subscriber;
                    isProcessCancelled = false;
                    sbcService.setIsScanCancelled(false); //reset the flag

                    //clear previous scanned info
                    sbcService.invoke({
                        slot: "clearScannedInfo",
                        value: 0
                    });

                    $(element).append(template({
                        defaultActionMsg: lex.get("sbc.offlineEngineering.scan.defaultMsg"),
                        datapoints: lex.get("sbc.offlineEngineering.select.datapoints"),
                        hdlogs: lex.get("sbc.offlineEngineering.select.hdlogs"),
                        alarms: lex.get("sbc.offlineEngineering.select.alarms"),
                        selectedAlarms:true,
                        selectedHdlogs:true
                    }));




                    subscriber.attach('changed', _attachSubscriber);
                    progress.prototype.buildProgress("#scan-datapoints-circle","#scan-alarms-circle",
                        "#scan-hdlogs-circle", "#sbcOfflineEngineering-scanView");


                    var datapointsContainer  = sbcService.getDataPoints();
                    var alarmsContainer = sbcService.getAlarms();
                    var hdlogsContainer = sbcService.getHdLogs();

                    var scanningInProgress = (datapointsContainer.getDataPointsScanningState()
                    ||  alarmsContainer.getAlarmListScanningState()
                    || hdlogsContainer.getHdLogsScanningState());

                    if(!scanningInProgress) {

                        subscriber.subscribe(datapointsContainer);
                        subscriber.subscribe(alarmsContainer);
                        subscriber.subscribe(hdlogsContainer);

                        datapointsContainer.setScannedDataPointsCount(0);
                        alarmsContainer.setScannedAlarmListCount(0);
                        hdlogsContainer.setScannedHDLogsCount(0);
                        
                        _startStopScanning();
                    }
                },

                /**
                 * validate user input
                 *
                 * @returns {boolean}: return true/false based on validity of user input
                 */

                validate: function () {
                    //TODO: validate user input
                    return new Promise(function (resolve) {
                        resolve(true);
                    });
                },

                /**
                 * clean up and save before going to next view
                 *
                 * @returns {Promise}: return promise to be resolved before going to next view
                 */
                next: function (event, params) {
                    return new Promise(function (resolve) {
                        //TODO:task to do before moving to next screen
                        params.selectedModules = selectedModules;
                        params.subscriber.detach("changed", _attachSubscriber);
                        resolve();
                    });
                },

                /**
                 * clean up and save before going to previous view
                 *
                 */
                back: function (event, params) {
                    return new Promise(function (resolve) {
                        //TODO:task to do before moving to previous screen
                        params.subscriber.detach("changed", _attachSubscriber);
                        resolve();
                    });
                },

                /**
                 * cancel operation
                 *
                 */

                cancel: function (component) {
                    cancelDialog = Dialogs.showYesNo({
                        title : lex.get("sbc.offlineEngineering.dialog.confirm"),
                        content:lex.get("sbc.offlineEngineering.scan.cancel.msg")
                    })
                        .yes(function (dialog) {
                            isProcessCancelled = true;
                            dialog.close();
                            cancelDialog = null;
                            _cancelScanOperation(component);
                            _startStopScanning(true);
                            $widgetContainer.find("#sbcOfflineEngineering-backBttn").click();
                        }).no(function(dialog) {
                        dialog.close();
                        cancelDialog = null;
                    });
                },

                /**
                 * data to be passed to widget to communicate between views
                 *
                 * @returns {json}: return key value pairs of data
                 */

                getData: function () {
                    //TODO: task to update data to be passed to widget
                    return {scannedModules : scannedList};
                },


                /**
                 * enable/disable status of visisble action buttons within the view
                 *
                 * @returns {json}: return action buttons status (enabled/disabled)
                 */
                /*
                 //Note: by default all buttons within the view are enabled.
                 // uncomment and update the code to conditionally enable or disable action buttons
                 enableDisableActionBttns: function () {
                 //TODO: update action buttons status
                 return {
                 disabledBack : false,
                 disabledNext : false,
                 disabledCancel:false
                 };
                 },
                 */
                params: {
                    vname: 'scanView',
                    id: 'scanView',
                    message: lex.get('sbc.offlineEngineering.scan'),
                    backBttnMsg: lex.get('sbc.offlineEngineering.back'),
                    nextBttnMsg: lex.get('sbc.offlineEngineering.next'),
                    isCancelAvailable: true,
                    cancelBttnMsg: lex.get('sbc.offlineEngineering.cancel')
                }
            };
        };

        return scanView;
    });
